#!/usr/bin/perl -w
# How do I get the complete spliced nucleotide sequence from the CDS section?

use Bio::DB::GenBank;
use Bio::Perl;
use Bio::SeqIO;
use Bio::Location::SplitLocationI

$infileFolder = "Infile_fol";
$OutFolder = "Outfile_fol";

# Output folder is made.
if (-d "$OutFolder") {
  system ("rm -r $OutFolder");
}
if (!-d "$OutFolder") {
  mkdir("$OutFolder", 0755);
}

opendir(DIR,$infileFolder);
@filenames = readdir(DIR);
close(DIR);

foreach $filename (@filenames) {
  if ($filename =~ /^EN/) {
    open(FILE,"$infileFolder/$filename");
    @fileContent = <FILE>;
    close FILE;
    
    foreach $line (@fileContent) {
      if ($line =~ /^VERSION/) {
        $line =~ /.*GI:(\d+)/;
        $ginum = $1;
        print "$filename\_$ginum\n";
        
        $db_obj = Bio::DB::GenBank->new;
        $seq_obj = $db_obj->get_Seq_by_gi("$ginum"); #ENSG00000001626_ENST00000003084
       # $in = Bio::SeqIO->new(-file => "205_Out_NucGBFilesfol/ENSG00000001626_ENST00000003084", -format => 'genbank' );

       # $seq_obj = $db->get_Seq_by_id($gi);

        open(OUT,">$OutFolder/$filename");
        foreach my $feat ( $seq_obj->top_SeqFeatures ) {
          if ( $feat->primary_tag eq 'CDS' ) {
            my $cds_obj = $feat->spliced_seq;
            print OUT ">",$feat->gff_string,"\n",$cds_obj->seq,"\n";
          }
        }
        close OUT;
      }
    }
  }
}

